
;   ASCII Table for CrASH 
;       By Kaid - 1999
; -------------------------


.INCLUDE CRASH82.INC 
Title:
.DB "AsciiT-82 * Kaid",0
        
        CALL CLEARLCD           ;Clear the text screen

        SET 3,(IY+$05)          ;Invert display
        LD HL,Title             ;Display the 'title'
        ROM_CALL(D_ZT_STR)
        RES 3,(IY+$05)          ;Restore normal display mode

        LD HL,Data              ;Display the two other strings
        LD DE,0001              ;We start at position (0,1)
        LD B,2                  ;Number of strings to display

Show_Str:

        INC DE                 
        INC DE                 ;Add 2 to postion of Y 

        LD (CURSOR_POS),DE      
        ROM_CALL(D_ZT_STR)     ;Show the string
        DJNZ Show_Str


        XOR A                   ;A=0

Start:

        LD (Code),A             ;Put the value of A in 'Code'

Start_2:

        LD HL,$0503             ;Display the ASCII code at position (5,3)
        LD (CURSOR_POS),HL
        LD HL,(Code)
        ROM_CALL(D_HL_DECI)     


        LD HL,$0805             ;Display the caracter at position (8,3)
        LD (CURSOR_POS),HL
        LD A,(Code)
        ROM_CALL(TR_CHARPUT)    


        CALL CR_KHAND           ;Wait for keypress


        CP K_MODE               ;[MODE] pushed ?
        JR Z,End

        CP K_DOWN               ;Down pushed ?
        JR Z,DecChar  

        CP K_UP                 ;Up pushed ?
        JR Z,IncChar 

        JP Start_2              ;Go to 'Start_2', pushed key isn't important


DecChar:
        LD A,(Code)             ;A=Code
        DEC A                   ;Decrement A

        LD B,0                  ;B=Min code

        JP Test_ASCII_Code      ;Go to 'Test_ASCII_Code'        

IncChar:
        LD A,(Code)             ;A=Code
        INC A                   ;Increment A
        LD B,225                ;B=Max code

Test_ASCII_Code:

        CP 225                  
        JR C,Start              ;There's no problems

        LD A,B                  ;A contains now min or max code
        JP Start                ;Go to 'Start'        

End:
        RET                     ;The end ...

Data .DB "Code:",0
     .DB "Char:",0
Code .DB 0
     .DB 0
